Index: trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 728)
@@ -80,5 +80,5 @@
       REAL tauh2so4tmp(ngridmx) ! Temporary h2so4 opacity used before scaling
       ! BENJAMIN MODIFS
-      real CLFtot,CLF1,CLF2
+      real CLFtot
       real totcloudfrac(ngridmx)
       logical clearsky
@@ -145,16 +145,12 @@
 !==================================================================
 
-        if (iaero_co2.ne.0) then
+      if (iaero_co2.ne.0) then
            iaer=iaero_co2
 !       1. Initialization
-            aerosol(:,:,iaer)=0.0
+            aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
 !       2. Opacity calculation
             if (aerofixco2.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
-               do ig=1, ngrid
-                  do l=1,nlayer
-                     aerosol(ig,l,iaer)=1.e-9
-                  end do
-                  !aerosol(ig,12,iaer)=4.0 ! single cloud layer option
-               end do
+               aerosol(1:ngridmx,1:nlayermx,iaer)=1.e-9
+               !aerosol(1:ngridmx,12,iaer)=4.0 ! single cloud layer option
             else
                DO ig=1, ngrid
@@ -179,20 +175,16 @@
                ENDDO
             end if ! if fixed or varying
-        end if ! if CO2 aerosols   
+      end if ! if CO2 aerosols   
 !==================================================================
 !     Water ice / liquid 
 !==================================================================
 
-        if (iaero_h2o.ne.0) then 
+      if (iaero_h2o.ne.0) then 
            iaer=iaero_h2o
 !       1. Initialization
-            aerosol(:,:,iaer)=0.0
+            aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
 !       2. Opacity calculation
             if (aerofixh2o.or.(i_h2oice.eq.0).or.clearsky) then
-               do ig=1,ngrid ! to stop the rad tran bug
-                  do l=1,nlayer
-                     aerosol(ig,l,iaer) =1.e-9
-                  end do
-               end do
+               aerosol(1:ngridmx,1:nlayermx,iaer) =1.e-9
 
                ! put cloud at cloudlvl
@@ -228,49 +220,51 @@
 
             else
+
                do ig=1, ngrid
                   do l=1,nlayer-1 ! to stop the rad tran bug
 
-                     if(CLFvarying)then
-                        CLF1    = max(cloudfrac(ig,l),0.01)
-                        CLFtot  = max(totcloudfrac(ig),0.01)
-                        CLF2    = CLF1/CLFtot 
-                        CLF2    = min(1.,CLF2)
-                     else
-                        CLF1=1.0
-                        CLF2=CLFfixval
-                     endif
-                     
-                     aerosol0 =                                   &
+                     aerosol(ig,l,iaer) =                                    & !modification by BC
                           (  0.75 * QREFvis3d(ig,l,iaer) /        &
                           ( rho_ice * reffrad(ig,l,iaer) )  ) *   &
                           !  pq(ig,l,i_h2oice) *                   & !JL I dropped the +1e-9 here to have the same
-                          !( pplev(ig,l) - pplev(ig,l+1) ) / g /   & !   opacity in the clearsky=true and the 
-                          !  CLF1				    !   clear=false/pq=0 case
+                          !( pplev(ig,l) - pplev(ig,l+1) ) / g       !   opacity in the clearsky=true and the 
+                                                                     !   clear=false/pq=0 case
                           ( pq(ig,l,i_h2oice) + 1.E-9 ) *         & ! Doing this makes the code unstable, so I have restored it (RW)
-                          ( pplev(ig,l) - pplev(ig,l+1) ) / g /   &  
-                            CLF1
-
-                     aerosol(ig,l,iaer) = -log(1 - CLF2 + CLF2*exp(-aerosol0)) 
-                     ! why no division in exponential?
-                     ! because its already done in aerosol0
-                     
-                     aerosol(ig,l,iaer) = max(aerosol(ig,l,iaer),1.e-9)
-                     aerosol(ig,l,iaer) = min(aerosol(ig,l,iaer),aerosol0)                     
-                     
+                          ( pplev(ig,l) - pplev(ig,l+1) ) / g 
+
                   enddo
                enddo
-            end if
-        end if ! End if h2o aerosol
+
+               if(CLFvarying)then
+                  call totalcloudfrac(cloudfrac,totcloudfrac,pplev,pq,aerosol(1:ngridmx,1:nlayermx,iaer))
+                  do ig=1, ngrid
+                     do l=1,nlayer-1 ! to stop the rad tran bug
+                        CLFtot  = max(totcloudfrac(ig),0.01)
+                        aerosol(ig,l,iaer)=aerosol(ig,l,iaer)/CLFtot
+                        aerosol(ig,l,iaer) = max(aerosol(ig,l,iaer),1.e-9)
+                     enddo
+                  enddo
+               else
+                  do ig=1, ngrid
+                     do l=1,nlayer-1 ! to stop the rad tran bug
+                        CLFtot  = CLFfixval
+                        aerosol(ig,l,iaer)=aerosol(ig,l,iaer)/CLFtot
+                        aerosol(ig,l,iaer) = max(aerosol(ig,l,iaer),1.e-9)
+                     enddo
+                  enddo
+              end if!(CLFvarying)
+            endif !(aerofixed.or.(i_h2oice.eq.0).or.clearsky)
+	      
+      end if ! End if h2o aerosol
 
 !==================================================================
 !             Dust 
 !==================================================================
-        if (iaero_dust.ne.0) then
+      if (iaero_dust.ne.0) then
           iaer=iaero_dust
-
 !         1. Initialization 
-            aerosol(:,:,iaer)=0.0
+          aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
           
-            topdust=30.0 ! km  (used to be 10.0 km) LK
+          topdust=30.0 ! km  (used to be 10.0 km) LK
 
 !       2. Opacity calculation
@@ -314,5 +308,5 @@
               ENDDO
             ENDDO
-        end if ! If dust aerosol   
+      end if ! If dust aerosol   
 
 !==================================================================
@@ -321,8 +315,8 @@
 ! added by LK
       if (iaero_h2so4.ne.0) then
-          iaer=iaero_h2so4
+         iaer=iaero_h2so4
 
 !       1. Initialization
-            aerosol(:,:,iaer)=0.0
+         aerosol(1:ngridmx,1:nlayermx,iaer)=0.0
 
 
@@ -330,28 +324,25 @@
 
 !           expfactor=0.
-           DO l=1,nlayer-1
-             DO ig=1,ngrid
-!             Typical mixing ratio profile
-
-                 zp=(preff/pplay(ig,l))**(70./30) !emulating topdust
-                 expfactor=max(exp(0.007*(1.-max(zp,1.))),1.e-3)
+         DO l=1,nlayer-1
+            DO ig=1,ngrid
+!              Typical mixing ratio profile
+
+               zp=(preff/pplay(ig,l))**(70./30) !emulating topdust
+               expfactor=max(exp(0.007*(1.-max(zp,1.))),1.e-3)
 
 !             Vertical scaling function
-              aerosol(ig,l,iaer)= (pplev(ig,l)-pplev(ig,l+1)) &
-               *expfactor
-
-
-             ENDDO
-           ENDDO
-            tauh2so4tmp(1:ngrid)=0.
-              DO l=1,nlayer
-                DO ig=1,ngrid
-                   tauh2so4tmp(ig) = tauh2so4tmp(ig) &
-                          +  aerosol(ig,l,iaer)
-                ENDDO
-              ENDDO
-            DO l=1,nlayer-1
-               DO ig=1,ngrid
-                  aerosol(ig,l,iaer) = max(1E-20, &
+               aerosol(ig,l,iaer)= (pplev(ig,l)-pplev(ig,l+1))*expfactor
+
+            ENDDO
+         ENDDO
+         tauh2so4tmp(1:ngrid)=0.
+         DO l=1,nlayer
+            DO ig=1,ngrid
+               tauh2so4tmp(ig) = tauh2so4tmp(ig) + aerosol(ig,l,iaer)
+            ENDDO
+         ENDDO
+         DO l=1,nlayer-1
+            DO ig=1,ngrid
+               aerosol(ig,l,iaer) = max(1E-20, &
                           1 &
                        *  pplev(ig,1) / preff &
@@ -359,6 +350,6 @@
                        /  tauh2so4tmp(ig))
 
-              ENDDO
             ENDDO
+         ENDDO
 
 ! 1/700. is assuming a "sulfurtau" of 1
Index: trunk/LMDZ.GENERIC/libf/phystd/aerosol_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aerosol_mod.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/aerosol_mod.F90	(revision 728)
@@ -5,8 +5,8 @@
 !  aerosol indexes: these are initialized in iniaerosol.F and should be 0 if the
 !                 corresponding aerosol was not activated in callphys.def
-      integer :: iaero_co2 
-      integer :: iaero_h2o
-      integer :: iaero_dust
-      integer :: iaero_h2so4
+      integer, save :: iaero_co2 
+      integer, save :: iaero_h2o
+      integer, save :: iaero_dust
+      integer, save :: iaero_h2so4
 
 !==================================================================
Index: trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 728)
@@ -14,4 +14,5 @@
       use ioipsl_getincom 
       use gases_h
+      use radii_mod, only : su_aer_radii,co2_reffrad,h2o_reffrad,dust_reffrad,h2so4_reffrad
       use aerosol_mod
 
@@ -74,5 +75,5 @@
 
       REAL reffrad(ngrid,nlayer,naerkind)
-      REAL nueffrad(ngrid,nlayer,naerkind)
+      REAL, SAVE :: nueffrad(ngridmx,nlayermx,naerkind)
 
 !     OUTPUT
@@ -171,15 +172,6 @@
       real pqtest(ngridmx,nlayer,nq)
 
-!     are particle radii fixed?
-      logical, save ::  radfixed
       real maxrad, minrad
-
-!     Local water cloud optical properties
-      real, parameter ::  rad_froid=35.0e-6 
-      real, parameter ::  rad_chaud=10.0e-6 
-      real, parameter ::  coef_chaud=0.13
-      real, parameter ::  coef_froid=0.09
-      real zfice
-      
+            
       real CBRT
       external CBRT
@@ -201,10 +193,6 @@
       qsiaer(:,:,:)=0.0
       giaer(:,:,:) =0.0
-      radfixed=.false.
 
       if(firstcall) then
-         if(kastprof)then
-            radfixed=.true.
-         endif  
 
          call system('rm -f surf_vals_long.out')
@@ -212,46 +200,14 @@
 !--------------------------------------------------
 !     Effective radius and variance of the aerosols
-
-
-!     these values will change once the microphysics gets to work
-!     UNLESS tracer=.false., in which case we should be working with
-!     a fixed aerosol layer, and be able to define reffrad in a 
-!     .def file. To be improved!
-!     Generalization of aerosols added by LK
-            do iaer = 1,naerkind
-              if (iaer.eq.iaero_co2) then ! active CO2 aerosols  
-                do l=1,nlayer
-                   do ig=1,ngrid
-                     reffrad(ig,l,iaer)  = 1.e-4
-                     nueffrad(ig,l,iaer) = 0.1 
-                   enddo
-                enddo
-              endif
-              if (iaer.eq.iaero_h2o) then ! active H2O aerosols
-                do l=1,nlayer
-                   do ig=1,ngrid
-                     reffrad(ig,l,iaer)  = 1.e-5
-                     nueffrad(ig,l,iaer) = 0.1 
-                   enddo
-                enddo
-              endif
-              if(iaer.eq.iaero_dust)then ! active dust
-                do l=1,nlayer
-                   do ig=1,ngrid
-                     reffrad(ig,l,iaer)  = 1.e-5
-                     nueffrad(ig,l,iaer) = 0.1 
-                   enddo
-                enddo
-              endif
-              if(iaer.eq.iaero_h2so4)then ! Active h2so4 aerosols
-                do l=1,nlayer
-                   do ig=1,ngrid
-                     reffrad(ig,l,iaer)  = 1.e-6
-                     nueffrad(ig,l,iaer) = 0.1
-                   enddo
-                enddo
-              endif
-            enddo
-
+         if(naerkind.gt.4)then
+            print*,'Code not general enough to deal with naerkind > 4 yet.'
+            call abort
+         endif
+         call su_aer_radii(reffrad,nueffrad)
+	 
+	 
+
+!--------------------------------------------------
+!     set up correlated k
          print*, "callcorrk: Correlated-k data base folder:",trim(datadir)
          call getin("corrkdir",corrkdir)
@@ -305,112 +261,27 @@
 !     Initialization on every call    
 
-      do l=1,nlayer
-         do ig=1,ngrid
-            do iaer=1,naerkind
-               nueffrad(ig,l,iaer) = 0.1 ! stays at 0.1
-            enddo
-         enddo
-      enddo
-
-
+!--------------------------------------------------
+!     Effective radius and variance of the aerosols
       do iaer=1,naerkind
 
-       if(iaer.eq.iaero_co2)then
-         if(radfixed)then
-           do l=1,nlayer
-            do ig=1,ngrid
-               reffrad(ig,l,iaer)    = 5.e-5 ! CO2 ice
-            enddo
-           enddo
-           print*,'CO2 ice particle size =',reffrad(1,1,iaer)/1.e-6,'um'
-         else 
-           maxrad=0.0
-           !averad=0.0
-           minrad=1.0
-           do l=1,nlayer
-
-             !masse = (pplev(ig,l) - pplev(ig,l+1))/g
-
-            do ig=1,ngrid
-               if(tracer.and.igcm_co2_ice.gt.0)then
-
-                  if(igcm_co2_ice.lt.1)then
-                     print*,'Tracers but no CO2 ice still'
-                     print*,'seems to be a problem...'
-                     print*,'Aborting in callcorrk.'
-                     stop
-                  endif
-                  reffrad(ig,l,iaer) = CBRT( 3*pq(ig,l,igcm_co2_ice)/ &
-                       (4*Nmix_co2*pi*rho_co2) )
-               endif
-               reffrad(ig,l,iaer) = max(reffrad(ig,l,iaer),1.e-6)
-               reffrad(ig,l,iaer) = min(reffrad(ig,l,iaer),500.e-6)
-               !averad = averad + reffrad(ig,l,iaer)*area(ig)
-               maxrad = max(reffrad(ig,l,iaer),maxrad)
-               minrad = min(reffrad(ig,l,iaer),minrad)
-            enddo
-           enddo
-           if(igcm_co2_ice.gt.0)then
-             print*,'Max. CO2 ice particle size = ',maxrad/1.e-6,' um'
-             print*,'Min. CO2 ice particle size = ',minrad/1.e-6,' um'
-           endif
-         endif
-       endif
-
-
-       if(iaer.eq.iaero_h2o)then
-          if(radfixed) then
-            do l=1,nlayer
-               do ig=1,ngrid
-                  !reffrad(ig,l,iaer) = 2.e-5 ! H2O ice
-                  reffrad(ig,l,iaer) = rad_chaud ! H2O ice
-
-                  zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
-                  zfice = MIN(MAX(zfice,0.0),1.0)
-                  reffrad(ig,l,2)= rad_chaud * (1.-zfice) + rad_froid * zfice
-                  nueffrad(ig,l,2) = coef_chaud * (1.-zfice) + coef_froid * zfice
-               enddo
-            enddo
-            print*,'H2O ice particle size=',reffrad(1,1,iaer)/1.e-6,'um'
-          else
-             if(water)then
-               maxrad=0.0
-               minrad=1.0
-               do l=1,nlayer
-                do ig=1,ngrid
-                  reffrad(ig,l,iaer) = CBRT( 3*pq(ig,l,igcm_h2o_ice)/ &
-                       (4*Nmix_h2o*pi*rho_ice) )
-                  reffrad(ig,l,iaer) = max(reffrad(ig,l,iaer),1.e-6)
-                  reffrad(ig,l,iaer) = min(reffrad(ig,l,iaer),100.e-6)
-
-                  maxrad = max(reffrad(ig,l,iaer),maxrad)
-                  minrad = min(reffrad(ig,l,iaer),minrad)
-                enddo
-               enddo
-               print*,'Max. H2O ice particle size = ',maxrad/1.e-6,' um'
-               print*,'Min. H2O ice particle size = ',minrad/1.e-6,' um'
-             endif
-         endif
-       endif
-
+         if ((iaer.eq.iaero_co2).and.tracer.and.(igcm_co2_ice.gt.0)) then ! treat condensed co2 particles.
+	    call co2_reffrad(pq,reffrad)
+            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
+            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
+	 end if
+         if ((iaer.eq.iaero_h2o).and.water) then ! treat condensed water particles. to be generalized for other aerosols
+	    call h2o_reffrad(pq,pt,reffrad,nueffrad)
+            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
+            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngridmx,1:nlayermx,iaer))/1.e-6,' um'
+         endif
          if(iaer.eq.iaero_dust)then
-            do l=1,nlayer
-               do ig=1,ngrid
-                  reffrad(ig,l,iaer) = 2.e-6 ! dust
-               enddo
-            enddo
+	    call dust_reffrad(reffrad)
             print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
          endif
-
          if(iaer.eq.iaero_h2so4)then
-            do l=1,nlayer
-               do ig=1,ngrid
-                  reffrad(ig,l,iaer) = 1.e-6 ! h2so4
-               enddo
-            enddo
+	    call h2so4_reffrad(reffrad)
             print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
          endif
-      enddo ! do iaer=1,naerkind
-         ! added by LK
+      end do !iaer=1,naerkind
 
 
@@ -641,7 +512,7 @@
       if(.not.kastprof)then
       ! IMPORTANT: Now convert from kg/kg to mol/mol
-      do k=1,L_LEVELS
-         qvar(k) = qvar(k)/epsi
-      end do
+         do k=1,L_LEVELS
+            qvar(k) = qvar(k)/(epsi+qvar(k)*(1.-epsi))
+         end do
       end if
 
@@ -764,6 +635,8 @@
             print*,'Maximum temperature is outside the radiative'
             print*,'transfer kmatrix bounds, exiting.'
-            !print*,'WARNING, OVERRIDING FOR TEST'
-            call abort
+	    print*,'level,grid,T',k,ig,tlevrad(k)
+            print*,'WARNING, OVERRIDING FOR TEST'
+            !call abort
+	    tlevrad(k)=tgasmax
          endif
       enddo
Index: trunk/LMDZ.GENERIC/libf/phystd/callkeys.h
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 728)
@@ -9,39 +9,21 @@
      &   , enertest                                                     &
      &   , callgasvis,Continuum,H2Ocont_simple,graybody                 &
-     &   , Nmix_co2, Nmix_h2o                                           &
-     &   , dusttau                                                      &
-     &   , meanOLR                                                      &
-     &   , specOLR                                                      &
-     &   , kastprof                                                     &
-     &   , noradsurf                                                    &
-     &   , Tstrat                                                       &
-     &   , newtonian                                                    &
-     &   , check_cpp_match                                              &
-     &   , force_cpp                                                    &
-     &   , tau_relax                                                    &
-     &   , testradtimes                                                 &
+     &   , Nmix_co2, radfixed, dusttau                                  &
+     &   , meanOLR, specOLR                                             &
+     &   , kastprof, noradsurf, Tstrat                                  &
+     &   , newtonian, tau_relax, testradtimes                           &
+     &   , check_cpp_match, force_cpp                                   &
      &   , rayleigh                                                     &
-     &   , stelbbody                                                    &
-     &   , stelTbb                                                      &
+     &   , stelbbody, stelTbb                                           &
      &   , tplanet                                                      &
-     &   , startype                                                     &
-     &   , Fat1AU                                                       &
+     &   , startype, Fat1AU                                             &
      &   , nearco2cond                                                  &
-     &   , tracer                                                       &
-     &   , varactive                                                    &
-     &   , varfixed                                                     &
-     &   , satval                                                       &
+     &   , tracer, mass_redistrib, varactive, varfixed, satval          &
      &   , sedimentation,water,watercond,waterrain                      &
-     &   , rainthreshold                                                &
      &   , aeroco2,aeroh2o,aeroh2so4                                    &
      &   , aerofixco2,aerofixh2o                                        &
-     &   , hydrology                                                    &
-     &   , sourceevol                                                   &
-     &   , icetstep                                                     &
-     &   , albedosnow                                                   &
-     &   , maxicethick                                                  &
-     &   , Tsaldiff                                                     &
-     &   , CLFfixval                                                    &
-     &   , CLFvarying                                                   &
+     &   , hydrology, sourceevol, icetstep, albedosnow                  &
+     &   , maxicethick, Tsaldiff                                        &
+     &   , CLFfixval, CLFvarying                                        &
      &   , n2mixratio                                                   &
      &   , co2supsat                                                    &
@@ -69,6 +51,8 @@
       logical nearco2cond
       logical tracer
+      logical mass_redistrib
       logical varactive
       logical varfixed
+      logical radfixed
       logical sedimentation
       logical water,watercond,waterrain
@@ -87,5 +71,4 @@
       real topdustref
       real Nmix_co2
-      real Nmix_h2o
       real dusttau
       real Fat1AU
@@ -94,5 +77,4 @@
       real tplanet
       real satval
-      real rainthreshold
       real CLFfixval
       real n2mixratio
Index: trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 728)
@@ -8,4 +8,6 @@
       use radinc_h, only : naerkind
       use gases_h
+      use radii_mod, only : co2_reffrad
+      use aerosol_mod, only : iaero_co2
 
       implicit none
@@ -146,6 +148,4 @@
       character(len=3) :: gasname
 
-      real reffradmin, reffradmax
-
       real ppco2
 
@@ -157,12 +157,4 @@
       call zerophys(ngridmx*nlayermx*nqmx,zq)
       call zerophys(ngridmx*nlayermx,zt)
-
-      !reffradmin=1.e-7
-      !reffradmax=5.e-4
-      !reffradmin=0.5e-7
-      !reffradmax=0.1e-3 ! FF data
-      reffradmin=0.1e-5
-      reffradmax=0.1e-3 ! JB data
-!     improve this in the future...
 
 !     Initialisation
@@ -319,24 +311,11 @@
 !     Gravitational sedimentation
             
-!     sedimentation computed from radius computed from q
-!     assuming that the ice is splitted in Nmix particle
+!     sedimentation computed from radius computed from q in module radii_mod
+	 call co2_reffrad(zq,reffrad)
+	 
          do  ilay=1,nlayer
             do ig=1, ngrid
 
-               reff = CBRT( 3*zq(ig,ilay,i_co2ice)/( 4*Nmix_co2*pi*rho_co2 ))
-
-               ! there should be a more elegant way of doing this...
-               if(reff.lt.1.e-16) reff=1.e-16
-
-               ! update reffrad for radiative transfer
-               if(reff.lt.reffradmin)then
-                  reffrad(ig,ilay,1)=reffradmin
-                  !print*,'reff below optical limit'
-               elseif(reff.gt.reffradmax)then
-                  reffrad(ig,ilay,1)=reffradmax
-                  !print*,'reff above optical limit'
-               else
-                  reffrad(ig,ilay,1)=reff
-               endif
+               reff = reffrad(ig,ilay,iaero_co2)
 
                call stokes                      &
Index: trunk/LMDZ.GENERIC/libf/phystd/inifis.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 726)
+++ trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 728)
@@ -132,4 +132,10 @@
          write(*,*) " tracer = ",tracer
 
+         write(*,*) "Run with or without atm mass update ",
+     &      " due to tracer evaporation/condensation?"
+         mass_redistrib=.false. ! default value
+         call getin("mass_redistrib",mass_redistrib)
+         write(*,*) " mass_redistrib = ",mass_redistrib
+
          write(*,*) "Diurnal cycle ?"
          write(*,*) "(if diurnal=false, diurnal averaged solar heating)"
@@ -377,13 +383,17 @@
          write(*,*)" CLFfixval = ",CLFfixval
 
-         write(*,*)"Number mixing ratio of CO2 ice particles:"
-         Nmix_co2=100000. ! default value
+         write(*,*)"fixed radii for Cloud particles?"
+         radfixed=.false. ! default value
+         call getin("radfixed",radfixed)
+         write(*,*)" radfixed = ",radfixed
+
+         if(kastprof)then
+            radfixed=.true.
+         endif  
+
+	 write(*,*)"Number mixing ratio of CO2 ice particles:"
+         Nmix_co2=1.e6 ! default value
          call getin("Nmix_co2",Nmix_co2)
          write(*,*)" Nmix_co2 = ",Nmix_co2
-
-         write(*,*)"Number mixing ratio of H2O ice particles:"
-         Nmix_h2o=10000000. ! default value
-         call getin("Nmix_h2o",Nmix_h2o)
-         write(*,*)" Nmix_h2o = ",Nmix_h2o
 
 !         write(*,*)"Number of radiatively active aerosols:"
@@ -499,9 +509,4 @@
          call getin("waterrain",waterrain)
          write(*,*) " waterrain = ",waterrain
-
-         write(*,*) "Precipitation threshold ?"
-         rainthreshold=0.011 ! default value (Emmanuel 1997)
-         call getin("rainthreshold",rainthreshold)
-         write(*,*) " rainthreshold = ",rainthreshold
 
          write(*,*) "Include surface hydrology ?"
Index: trunk/LMDZ.GENERIC/libf/phystd/largescale.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/largescale.F90	(revision 728)
+++ trunk/LMDZ.GENERIC/libf/phystd/largescale.F90	(revision 728)
@@ -0,0 +1,148 @@
+      subroutine largescale(ptimestep, pplev, pplay, pt, pq,   &
+                        pdt, pdq, pdtlsc, pdqvaplsc, pdqliqlsc, rneb)
+
+      use watercommon_h, only : RLVTT, RCPD, RVTMP2,  &
+          T_h2O_ice_clouds,T_h2O_ice_liq,Psat_water,Lcpdqsat_water
+      IMPLICIT none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates large-scale (stratiform) H2O condensation.
+!     
+!     Authors
+!     -------
+!     Adapted from the LMDTERRE code by R. Wordsworth (2009)
+!     Original author Z. X. Li (1993)
+!     
+!==================================================================
+
+#include "dimensions.h" 
+#include "dimphys.h"
+#include "comcstfi.h"
+
+#include "fisice.h"
+#include "callkeys.h"
+#include "tracer.h"
+
+
+
+!     Arguments
+      REAL ptimestep                 ! intervalle du temps (s)
+      REAL pplev(ngridmx,nlayermx+1) ! pression a inter-couche
+      REAL pplay(ngridmx,nlayermx)   ! pression au milieu de couche
+      REAL pt(ngridmx,nlayermx)      ! temperature (K)
+      real pq(ngridmx,nlayermx,nqmx) ! tracer mixing ratio (kg/kg)
+      REAL pdt(ngridmx,nlayermx)     ! physical temperature tenedency (K/s)
+      REAL pdq(ngridmx,nlayermx,nqmx)! physical tracer tenedency (K/s)
+      REAL pdtlsc(ngridmx,nlayermx)  ! incrementation de la temperature (K)
+      REAL pdqvaplsc(ngridmx,nlayermx) ! incrementation de la vapeur d'eau
+      REAL pdqliqlsc(ngridmx,nlayermx) ! incrementation de l'eau liquide
+      REAL rneb(ngridmx,nlayermx)    ! fraction nuageuse
+
+
+!     Options du programme
+      REAL ratqs   ! determine largeur de la distribution de vapeur
+      PARAMETER (ratqs=0.2)
+
+!     Variables locales
+      REAL CBRT
+      EXTERNAL CBRT
+      INTEGER i, k , nn
+      INTEGER,PARAMETER :: niter=4
+      REAL zt(ngridmx), zq(ngridmx)
+      REAL zcond(ngridmx),zcond_iter
+      REAL zdelq(ngridmx)
+      REAL zqs(ngridmx), zdqs(ngridmx)
+      REAL psat_tmp
+      
+! evaporation calculations
+      REAL dqevap(ngridmx,nlayermx),dtevap(ngridmx,nlayermx)     
+      REAL qevap(ngridmx,nlayermx,nqmx)
+      REAL tevap(ngridmx,nlayermx)
+
+      REAL zcor(ngridmx), zdelta(ngridmx), zcvm5(ngridmx)
+      REAL zx_q(ngridmx)
+      REAL Nmix_local,zfice
+
+!     GCM -----> subroutine variables, initialisation of outputs
+
+      pdtlsc(1:ngridmx,1:nlayermx)  = 0.0
+      pdqvaplsc(1:ngridmx,1:nlayermx)  = 0.0
+      pdqliqlsc(1:ngridmx,1:nlayermx) = 0.0
+      rneb(1:ngridmx,1:nlayermx) = 0.0
+
+
+      ! Evaporate cloud water/ice
+      call evap(ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
+      ! note: we use qevap but not tevap in largescale/moistadj
+            ! otherwise is a big mess
+
+
+!  Boucle verticale (du haut vers le bas)
+   DO k = nlayermx, 1, -1
+
+      zt(1:ngridmx)=pt(1:ngridmx,k)+(pdt(1:ngridmx,k)+dtevap(1:ngridmx,k))*ptimestep
+      zq(1:ngridmx)=qevap(1:ngridmx,k,igcm_h2o_vap) !liquid water is included in qevap
+
+!     Calculer la vapeur d'eau saturante et 
+!     determiner la condensation partielle
+      DO i = 1, ngridmx
+
+         if(zt(i).le.15.) zt(i)=15.   ! check too low temperatures
+!         call watersat(zt(i),pplay(i,k),zqs(i))
+         call Psat_water(zt(i),pplay(i,k),psat_tmp,zqs(i))
+ 
+         zdelq(i) = ratqs * zq(i)
+	 if(zq(i)+zdelq(i).lt.0.999) then
+	    rneb(i,k) = (zq(i)+zdelq(i)-zqs(i)) / (2.0*zdelq(i))
+	    zx_q(i) = (zq(i)+zdelq(i)+zqs(i))/2.0 !water vapor in cloudy sky
+            if (rneb(i,k) .LE. 0.0) zx_q(i) = 0.0
+            if (rneb(i,k) .GE. 1.0) zx_q(i) = zq(i)
+            rneb(i,k) = MAX(0.0,MIN(1.0,rneb(i,k)))
+	 else
+	    if(zq(i).gt.zqs(i)) then
+	       rneb(i,k)=1.
+	       zx_q(i)=zq(i)
+	    else
+	       rneb(i,k)=0.
+	       zx_q(i)=zqs(i)  !no condensation needed
+	    Endif
+	 Endif
+
+!        iterative process to stabilize the scheme when large water amounts JL12
+         zcond(i) = 0.0
+         Do nn=1,niter  
+!            call watersat_grad(zt(i),zqs(i),zdqs(i))
+	    call Lcpdqsat_water(zt(i),pplay(i,k),psat_tmp,zqs(i),zdqs(i))
+            zcond_iter = MAX(0.0,(zx_q(i)-zqs(i))*rneb(i,k)/(1.+zdqs(i)))	   
+               !zcond always postive! cannot evaporate clouds!
+               !this is why we must reevaporate before largescale
+            zx_q(i) = zx_q(i) - zcond_iter
+	    zcond(i) = zcond(i) + zcond_iter
+	    zt(i) = zt(i) + zcond_iter*RLVTT/RCPD
+            call Psat_water(zt(i),pplay(i,k),psat_tmp,zqs(i))
+	 End do ! niter
+
+
+         zcond(i) = zcond(i)/ptimestep ! added by RDW
+      ENDDO
+
+!     Tendances de t et q
+         pdqvaplsc(1:ngridmx,k)  = dqevap(1:ngridmx,k) - zcond(1:ngridmx)
+         pdqliqlsc(1:ngridmx,k) = - pdqvaplsc(1:ngridmx,k)
+         pdtlsc(1:ngridmx,k)  = pdqliqlsc(1:ngridmx,k)*RLVTT/RCPD
+
+   Enddo ! k= nlayermx, 1, -1
+   
+      !print*,'qsat=',zqs
+      !print*,'q=',q
+      !print*,'dq=',pdqvaplsc*ptimestep
+      !print*,'dT in LS=',pdtlsc*ptimestep
+
+      !print*,'rice=',rice
+      !print*,'rneb=',rneb
+
+      return
+      end
